#include <stdio.h>
#include <allegro.h>

struct ColorVal {
	unsigned char Pos,PalVal;
};

int main(int argc, char *argv[])
{

unsigned int map[75][75];												// Variables utilises
char	message[20],file[8];
struct  ColorVal temp,opt_palette[4];
BITMAP *snes_image,*snes_sprite,*sprite_buffer1,*sprite_buffer2,*snes_map;
PALETTE	pal;
unsigned int x_map_spr,y_map_spr,temp_map_spr;
int i,x_sprite,y_sprite,x_map,y_map,sprite_number,image_X,image_Y;
int color1,color2,same_sprite,sprite_scan,sprite_save;
int	continue_scan,x_scroll,y_scroll,opt_perte,tot_perte;
FILE *f_graph,*f_level,*f_info;
RGB tricol1,tricol2,tricol3,tricol4;
RGB col1={63,10,10,0};
RGB col2={10,10,63,0};
RGB col3={0,20,0,0};
RGB colall={10,30,40,0};

	printf("       (SNE)s (S)prite (CONV)ertisseur\n");
	printf("       ------------ V 0.9A -----------\n\n");

	if(argc!=2) {													// Initialisation du programme
		printf(" o Format : Snesconv image.bmp");
		exit(0);
		}

	printf(" o Taille X de l'image en pixels (16..1200): ");
	scanf("%d",&image_X);
	printf(" o Taille Y de l'image en pixels (16..1200): ");
	scanf("%d",&image_Y);
	printf(" o Optimisation des sprites avec pertes (0..768): ");
	scanf("%d",&opt_perte);

	image_X=image_X/16;
	image_Y=image_Y/16;

	i=0;
	do {
	file[i]=*(argv[1]+i);
	}
	while(file[i++]!='.');
	file[--i]=0;

	printf("\n -> Nombres de tiles X : %d\n",image_X);
	printf(" -> Nombres de tiles Y : %d\n",image_Y);
	sprintf(message,"%s.bin",file);
	if ((f_graph=fopen(message,"wb"))==NULL) {
		printf(" -> Creation du fichier %s impossible.\n",message);
		readkey();
		exit(0);
		} else {
		printf(" -> Creation du fichier %s reussie.\n",message);
		}
	sprintf(message,"%s.lvl",file);
	if ((f_level=fopen(message,"wb"))==NULL) {
		printf(" -> Creation du fichier %s impossible.\n",message);
		readkey();
		exit(0);
		} else {
		printf(" -> Creation du fichier %s reussie.\n",message);
		}
	sprintf(message,"%s.nfo",file);
	if ((f_info=fopen(message,"wb"))==NULL) {
		printf(" -> Creation du fichier %s impossible",message);
		readkey();
		exit(0);
		} else {
		printf(" -> Creation du fichier %s reussie.",message);
	}
	printf("\n\n  - Appuyez sur une touche pour continuer -");

	allegro_init();
	install_keyboard();
	readkey();
	set_gfx_mode(GFX_VESA2L,640,480,0,0);
	snes_image=create_bitmap(16*image_X,16*image_Y);
	snes_sprite=create_bitmap(617,(((image_X*image_Y+1)/36)+1)*17);
	snes_map=create_bitmap(image_X*20,image_Y*12);
	sprite_buffer1=create_bitmap(16,16);
	sprite_buffer2=create_bitmap(16,16);
	clear_to_color(snes_sprite,6);
	clear(snes_image);
	snes_image=load_bitmap(argv[1],pal);
	set_palette(pal);
	get_color(0,&tricol1);
	get_color(1,&tricol2);
	get_color(2,&tricol3);
	get_color(3,&tricol4);
	opt_palette[1].PalVal=tricol1.r+tricol1.g+tricol1.b;
	opt_palette[1].Pos=1;
	opt_palette[2].PalVal=tricol2.r+tricol2.g+tricol2.b;
	opt_palette[2].Pos=2;
	opt_palette[3].PalVal=tricol3.r+tricol3.g+tricol3.b;
	opt_palette[3].Pos=3;
	opt_palette[4].PalVal=tricol4.r+tricol4.g+tricol4.b;
	opt_palette[4].Pos=4;

	for(i=1;i<4;i++) {
		if(opt_palette[i].PalVal>opt_palette[i+1].PalVal) {
			temp=opt_palette[i];
			opt_palette[i]=opt_palette[i+1];
			opt_palette[i+1]=temp;
			i=1;
			}
	}

	set_color(4,&col1);
	set_color(5,&col2);
	set_color(6,&col3);
	for(color1=7;color1<256;color1++) {
		set_color(color1,&colall);
		}
	rect(screen,9,9,266,234,4);
	rect(screen,268,9,630,234,4);
	rect(screen,9,236,630,393,4);
	rect(screen,9,395,580,470,5);
	rect(screen,582,395,630,470,4);
	rectfill(screen,584,397,628,413,0);
	rectfill(screen,584,415,628,431,1);
	rectfill(screen,584,433,628,449,2);
	rectfill(screen,584,451,628,468,3);
	text_mode(-1);
	for(i=0;i<4;i++) {
		sprintf(message,"%d",opt_palette[i+1].Pos);
		textout(screen,font,message,603,402+i*18,3-i);
		}
	text_mode(0);

	if((image_X<17)&&(image_Y<15)) {
	blit(snes_image,screen,0,0,10,10,image_X*16,image_Y*16);
	}
	else if((image_X>16)&&(image_Y>14)) {
	blit(snes_image,screen,0,0,10,10,16*16,14*16);
	}
	else if(image_X>16) {
	blit(snes_image,screen,0,0,10,10,16*16,image_Y*16);
	}
	else
	{
	blit(snes_image,screen,0,0,10,10,image_X*16,14*16);
	}

textout(screen,font,">> Initialisation de la MAP et des sprites.",11,397,3);

sprite_number=0;													// Cration MAP
	for(y_map=0;y_map<image_Y;y_map++) {
		for(x_map=0;x_map<image_X;x_map++) {
			map[x_map][y_map]=sprite_number++;
			}
		}
																	// Cration SPRITES
	for(y_map=0;y_map<image_Y;y_map++) {
		for(x_map=0;x_map<image_X;x_map++) {
				blit(snes_image,sprite_buffer1,x_map*16,y_map*16,0,0,16,16);
				blit(sprite_buffer1,snes_sprite,0,0,(map[x_map][y_map]*17)%(36*17)
				,((map[x_map][y_map])/36)*17,16,16);
			}
		}

clear(snes_map);
blit(snes_map,screen,0,0,290,40,16*20,14*12);
if(image_X*image_Y>252) {
blit(snes_sprite,screen,0,0,11,238,617,153);
} else {
blit(snes_sprite,screen,0,0,11,238,617,(((image_X*image_Y)/36)+1)*17); }

																	// Optimisation sprites
textout(screen,font,">> Optimisation des sprites. Cel peut prendre plusieurs minutes...",11,407,3);

	for(sprite_number=0;sprite_number<image_X*image_Y;sprite_number++) {
		blit(snes_sprite,sprite_buffer1,(sprite_number*17)%(36*17),
		((sprite_number)/36)*17,0,0,16,16);
		for(sprite_scan=sprite_number+1;sprite_scan<image_X*image_Y;sprite_scan++) {
			blit(snes_sprite,sprite_buffer2,(sprite_scan*17)%(36*17),
			((sprite_scan)/36)*17,0,0,16,16);
			same_sprite=1;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,x_sprite,y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						sprite_scan=image_X*image_Y;
						}
					}
				}
			if(same_sprite==0) {
			same_sprite=2;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,15-x_sprite,y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						sprite_scan=image_X*image_Y;
						}
					}
				} }
			if(same_sprite==0) {
			same_sprite=3;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,x_sprite,15-y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						sprite_scan=image_X*image_Y;
						}
					}
				} }
			if(same_sprite==0) {
			same_sprite=4;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,15-x_sprite,15-y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						sprite_scan=image_X*image_Y;
						}
					}
				} }

			if((same_sprite>0)&&(sprite_scan<image_X*image_Y)) {
				continue_scan=0;
				for(sprite_save=sprite_scan;sprite_save<image_X*image_Y;sprite_save++) {
					blit(snes_sprite,sprite_buffer2,((sprite_save+1)*17)%(36*17),
					(((sprite_save+1))/36)*17,0,0,16,16);
					blit(sprite_buffer2,snes_sprite,0,0,((sprite_save)*17)%(36*17),
					(((sprite_save))/36)*17,16,16);
					}
				}
			else {
				continue_scan=1;
				}
			if (continue_scan==0) {
				sprite_scan--;
				}
			}
		}

blit(snes_sprite,screen,0,0,11,238,617,153);

textout(screen,font,">> Cration de la MAP. Cel peut prendre plusieurs minutes...",11,417,3);

for(y_map=0;y_map<image_Y;y_map++) {
	for(x_map=0;x_map<image_X;x_map++) {
		map[x_map][y_map]=0;
		}
	}

clear(snes_map);

for(sprite_number=0;sprite_number<image_X*image_Y;sprite_number++) {
	blit(snes_sprite,sprite_buffer1,((sprite_number)*17)%(36*17),
	(((sprite_number))/36)*17,0,0,16,16);
	for(y_map=0;y_map<image_Y;y_map++) {									// Affichage de la MAP
		for(x_map=0;x_map<image_X;x_map++) {
			blit(snes_image,sprite_buffer2,x_map*16,y_map*16,0,0,16,16);
			same_sprite=1;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,x_sprite,y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						x_map=image_X;
						y_map=image_Y;
						}
					}
				}
			if(same_sprite==0) {
			same_sprite=2;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,15-x_sprite,y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						x_map=image_X;
						y_map=image_Y;
						}
					}
				} }
			if(same_sprite==0) {
			same_sprite=3;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,x_sprite,15-y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						x_map=image_X;
						y_map=image_Y;
						}
					}
				} }
			if(same_sprite==0) {
			same_sprite=4;
			tot_perte=0;
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=getpixel(sprite_buffer1,x_sprite,y_sprite);
					color2=getpixel(sprite_buffer2,15-x_sprite,15-y_sprite);
					if(color1!=color2) {
						tot_perte+=abs(color1-color2);
						if(tot_perte>opt_perte) {
						same_sprite=0; }
						}
					if(color2==6) {
						x_map=image_X;
						y_map=image_Y;
						}
					}
				} }

			if((same_sprite>0)&&(x_map<image_X)&&(y_map<image_Y)) {
				map[x_map][y_map]=sprite_number+1024*(same_sprite-1);
				sprintf(message,"%x",sprite_number);
				textout(snes_map,font,message,x_map*20,y_map*12,2+same_sprite);
				}
			}
		}
	}

blit(snes_map,screen,0,0,290,40,16*20,14*12);

sprite_number=0;

	for(y_sprite=0;y_sprite<image_Y;y_sprite++) {
		for(x_sprite=0;x_sprite<image_X;x_sprite++) {
				if((map[x_sprite][y_sprite]<1024)&&(map[x_sprite][y_sprite]>sprite_number))
				sprite_number=map[x_sprite][y_sprite];
			}
		}

sprite_number++;
sprintf(message,">> Nombre de sprites reconnus : %d",sprite_number);
textout(screen,font,message,11,437,3);

textout(screen,font,">> Sauvegarde des informations obtenues.",11,427,3);

	sprintf(message,"=> Taille X16 : %d %c%c",image_X,13,10);
	fputs(message,f_info);
	sprintf(message,"=> Taille Y16 : %d %c%c",image_Y,13,10);
	fputs(message,f_info);
	sprintf(message,"=> Nombre de sprites : %d %c%c",sprite_number,13,10);
	fputs(message,f_info);
	sprintf(message,"=> Qualit de l'image par optimisation  perte : %d",opt_perte);
	fputs(message,f_info);

	for(sprite_scan=0;sprite_scan<sprite_number;sprite_scan++) {
		blit(snes_sprite,sprite_buffer1,(sprite_scan*17)%(36*17),
		((sprite_scan)/36)*17,0,0,16,16);
			for(y_sprite=0;y_sprite<16;y_sprite++) {
				x_map_spr=0;
				y_map_spr=0;
				for(x_sprite=0;x_sprite<16;x_sprite++) {
					color1=	opt_palette[getpixel(sprite_buffer1,x_sprite,y_sprite)].Pos;
					if(color1==0) {
						x_map_spr=x_map_spr<<1;
						x_map_spr=x_map_spr++;
						y_map_spr=y_map_spr<<1;
						y_map_spr=y_map_spr++;
					} else if(color1==1) {
						x_map_spr=x_map_spr<<1;
						x_map_spr=x_map_spr++;
						y_map_spr=y_map_spr<<1;
					} else if(color1==2) {
						x_map_spr=x_map_spr<<1;
						y_map_spr=y_map_spr<<1;
						y_map_spr=y_map_spr++;
					} else {
						x_map_spr=x_map_spr<<1;
						y_map_spr=y_map_spr<<1;
					}
				}
				temp_map_spr=x_map_spr>>8;
				fputc(temp_map_spr,f_graph);
				fputc(x_map_spr,f_graph);
				temp_map_spr=y_map_spr>>8;
				fputc(temp_map_spr,f_graph);
				fputc(y_map_spr,f_graph);
			}
		}

	for(y_sprite=0;y_sprite<image_Y;y_sprite++) {
		for(x_sprite=0;x_sprite<image_X;x_sprite++) {
			sprite_number=map[x_sprite][y_sprite];
			if((sprite_number>=1024)&&(sprite_number<2048)) {
				sprite_number=32767&sprite_number;
				sprite_number=16384|sprite_number;}
			else if((sprite_number>=2048)&&(sprite_number<3072)) {
				sprite_number=49151&sprite_number;
				sprite_number=32768|sprite_number;}
			else if(sprite_number>=3072) {
				sprite_number=16384|sprite_number;
				sprite_number=32768|sprite_number;
				}

			map[x_sprite][y_sprite]=map[x_sprite][y_sprite]%1024;
			fputc(*(&map[x_sprite][y_sprite]+1),f_level);
			fputc(map[x_sprite][y_sprite],f_level);
			}
		}

	fclose(f_graph);
	fclose(f_level);
	fclose(f_info);

if(image_X<17&&image_Y<15) {
textout(screen,font,">> SUCCES ! Appuyez sur ESPACE pour continuer...",11,447,3);
while(!key[KEY_SPACE]) { }
}
else
{
textout(screen,font,">> SUCCES !  Scrolling = H/B/G/D   Quitter = ESPACE",11,447,3);
x_scroll=0;
y_scroll=0;

do
{
if((key[KEY_LEFT])&&(x_scroll>0))
		x_scroll-=1;
if((key[KEY_UP])&&(y_scroll>0))
		y_scroll-=1;
if((key[KEY_RIGHT])&&(image_X-x_scroll/4>16))
		x_scroll+=1;
if((key[KEY_DOWN])&&(image_Y-y_scroll/4>14))
		y_scroll+=1;
	blit(snes_map,screen,x_scroll*5,y_scroll*3,290,40,16*20,14*12);
	if((image_X>16)&&(image_Y>14)) {
	blit(snes_image,screen,x_scroll*4,y_scroll*4,10,10,16*16,16*14); }
	else if(image_X>16) {
	blit(snes_image,screen,x_scroll*4,y_scroll*4,10,10,16*16,16*image_Y); }
	else {
	blit(snes_image,screen,x_scroll*4,y_scroll*4,10,10,16*image_X,16*14); }
}
while(!key[KEY_SPACE]);
}

	destroy_bitmap(snes_image);
	destroy_bitmap(snes_sprite);
	destroy_bitmap(snes_map);
	destroy_bitmap(sprite_buffer1);
	destroy_bitmap(sprite_buffer2);

	allegro_exit();
	return(0);
}
